=== lib/test/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

cmake_minimum_required ( VERSION 2.8 )

#include ( CTest )

set ( NEW_PATH "$ENV{PATH}:${EXAMPLE_PATH}" )

set ( CHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${CMAKE_BINARY_DIR}/lib/etc" )

set ( INSTALLCHECK_ENVIRONMENT "OPENTURNS_WRAPPER_PATH=${WRAPPER_PATH}"
                               "OPENTURNS_CONFIG_PATH=${SYSCONFIG_PATH}/openturns"
                               "OPENTURNS_NUMERICALSAMPLE_PATH=${SAMPLE_PATH}"
                               "PATH=${NEW_PATH}"
    )

# This macro compiles on the fly and run the corresponding pre-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set ( CHECK_TO_BE_RUN )
macro ( ot_check_test TESTNAME )
  set ( TESTNAME_TGT t_${TESTNAME} )
  set ( TESTNAME_SRC ${TESTNAME_TGT}.cxx )
  set ( TESTNAME_OUT ${TESTNAME_TGT}.expout )
  get_source_file_property ( OUTFILE_LOC ${TESTNAME_OUT} LOCATION )
  add_executable ( ${TESTNAME_TGT} EXCLUDE_FROM_ALL ${TESTNAME_SRC} )
  target_link_libraries ( ${TESTNAME_TGT} OT )
  set_target_properties ( ${TESTNAME_TGT} PROPERTIES
                                          INSTALL_RPATH "${CMAKE_BINARY_DIR}/lib/src;${CMAKE_INSTALL_RPATH}" )
  get_target_property ( TESTNAME_LOC ${TESTNAME_TGT} LOCATION )

  set ( _CMD )
  set ( _PRE )
  set ( _POST )
  set ( _PARAMS )
  set ( _IGNOREOUT OFF )
  foreach ( _ARG ${ARGN} )
    string ( TOUPPER ${_ARG} ARG )
    if ( ${ARG} MATCHES PRE )
      set ( _CMD PRE )
    elseif ( ${ARG} MATCHES POST )
      set ( _CMD POST )
    elseif ( ${ARG} MATCHES PARAMS )
      set ( _CMD PARAMS )
    elseif ( ${ARG} MATCHES IGNOREOUT )
      set ( _IGNOREOUT ON )
    else ( ${ARG} MATCHES PRE )
      if ( ${_CMD} MATCHES PRE )
        set ( _PRE "${_PRE} ${_ARG} && " )
      elseif ( ${_CMD} MATCHES POST )
        set ( _POST "${_POST} && ${_ARG}" )
      elseif ( ${_CMD} MATCHES PARAMS )
        set ( _PARAMS "${_PARAMS} ${_ARG}" )
      endif  ( ${_CMD} MATCHES PRE )
      set ( _CMD )
    endif ( ${ARG} MATCHES PRE )
  endforeach ( _ARG )

  if (_IGNOREOUT)
    set ( COMMAND "( ${TESTNAME_LOC} ${_PARAMS} > /dev/null )" )
  else (_IGNOREOUT)
    set ( COMMAND "( ${TESTNAME_LOC} ${_PARAMS} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out ) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out" )
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    add_test ( cppcheck_${TESTNAME} "sh" "-c" "${_PRE}${COMMAND}${_POST}" )
  else (_PRE OR _POST)
    add_test ( cppcheck_${TESTNAME} "sh" "-c" "${COMMAND}" )
  endif (_PRE OR _POST)
  set_tests_properties ( cppcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${CHECK_ENVIRONMENT}" )
  list ( APPEND CHECK_TO_BE_RUN ${TESTNAME_TGT} )
  install ( FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH} 
            PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
          )
endmacro ( ot_check_test )

# This macro compiles on the fly and run the corresponding post-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set ( INSTALLCHECK_TO_BE_RUN )
macro ( ot_installcheck_test TESTNAME )
  set ( TESTNAME_TGT t_${TESTNAME} )
  set ( TESTNAME_SRC ${TESTNAME_TGT}.cxx )
  set ( TESTNAME_OUT ${TESTNAME_TGT}.expout )
  get_source_file_property ( OUTFILE_LOC ${TESTNAME_OUT} LOCATION )
  add_executable ( ${TESTNAME_TGT} EXCLUDE_FROM_ALL ${TESTNAME_SRC} )
  target_link_libraries ( ${TESTNAME_TGT} OT )
  get_target_property ( TESTNAME_LOC ${TESTNAME_TGT} LOCATION )

  set ( _CMD )
  set ( _PRE )
  set ( _POST )
  set ( _PARAMS )
  set ( _IGNOREOUT OFF )
  foreach ( _ARG ${ARGN} )
    string ( TOUPPER ${_ARG} ARG )
    if ( ${ARG} MATCHES PRE )
      set ( _CMD PRE )
    elseif ( ${ARG} MATCHES POST )
      set ( _CMD POST )
    elseif ( ${ARG} MATCHES PARAMS )
      set ( _CMD PARAMS )
    elseif ( ${ARG} MATCHES IGNOREOUT )
      set ( _IGNOREOUT ON )
    else ( ${ARG} MATCHES PRE )
      if ( ${_CMD} MATCHES PRE )
        set ( _PRE "${_PRE} ${_ARG} && " )
      elseif ( ${_CMD} MATCHES POST )
        set ( _POST "${_POST} && ${_ARG}" )
      elseif ( ${_CMD} MATCHES PARAMS )
        set ( _PARAMS "${_PARAMS} ${_ARG}" )
      endif  ( ${_CMD} MATCHES PRE )
      set ( _CMD )
    endif ( ${ARG} MATCHES PRE )
  endforeach ( _ARG )

  if (_IGNOREOUT)
    set ( COMMAND "( ${TESTNAME_LOC} ${_PARAMS} > /dev/null )" )
  else (_IGNOREOUT)
    set ( COMMAND "( ${TESTNAME_LOC} ${_PARAMS} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out ) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out" )
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    add_test ( cppinstallcheck_${TESTNAME} "sh" "-c" "${_PRE}${COMMAND}${_POST}" )
  else (_PRE OR _POST)
    add_test ( cppinstallcheck_${TESTNAME} "sh" "-c" "${COMMAND}" )
  endif (_PRE OR _POST)
  set_tests_properties ( cppinstallcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${INSTALLCHECK_ENVIRONMENT}" )
  list ( APPEND INSTALLCHECK_TO_BE_RUN ${TESTNAME_TGT} )
  install ( FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH}
            PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
          )
endmacro ( ot_installcheck_test )

include_directories ( ${INTERNAL_INCLUDE_DIRS} )

## Pre-installation tests

# Common
ot_check_test ( Object_std )
ot_check_test ( OStream_std )
ot_check_test ( PersistentObject_std )
ot_check_test ( Pointer_std )
ot_check_test ( Pointer_cast )
ot_check_test ( Exception_std )
ot_check_test ( Log_std )
ot_check_test ( IdFactory_std IGNOREOUT )
ot_check_test ( ComparisonOperator_std )
ot_check_test ( Study_save IGNOREOUT )
ot_check_test ( Study_load IGNOREOUT )
ot_check_test ( ResourceMap_std IGNOREOUT )
ot_check_test ( Catalog_std IGNOREOUT )
ot_check_test ( AtomicFunctions_std IGNOREOUT )

# Type
ot_check_test ( Collection_std )
ot_check_test ( Domain_std )
ot_check_test ( Indices_std )
ot_check_test ( Interval_std )
ot_check_test ( Description_std )
ot_check_test ( NumericalPoint_std )
ot_check_test ( NumericalPoint_description )
ot_check_test ( Matrix_std )
ot_check_test ( IdentityMatrix_std )
ot_check_test ( Tensor_std )
ot_check_test ( SymmetricTensor_std )
ot_check_test ( SquareMatrix_std )
ot_check_test ( SymmetricMatrix_std )
ot_check_test ( MatrixSolveLinearSystem_std )
ot_check_test ( MatrixSingularValues_std )
ot_check_test ( SquareMatrixLapack_std )
ot_check_test ( SymmetricMatrixLapack_std )
ot_check_test ( Cache_std )
ot_check_test ( RegularGrid_std )
ot_check_test ( ComplexMatrix_std )
ot_check_test ( SquareComplexMatrix_std )
ot_check_test ( HermitianMatrix_std )
ot_check_test ( TriangularComplexMatrix_std )

# Func
ot_check_test ( LibraryLoader_std )
ot_check_test ( LinearNumericalMathEvaluationImplementation_std )
ot_check_test ( ConstantNumericalMathGradientImplementation_std )
ot_check_test ( LinearNumericalMathFunction_std )
ot_check_test ( LinearCombinationEvaluationImplementation_std )
ot_check_test ( LinearCombinationGradientImplementation_std )
ot_check_test ( LinearCombinationHessianImplementation_std )
ot_check_test ( QuadraticNumericalMathEvaluationImplementation_std )
ot_check_test ( LinearNumericalMathGradientImplementation_std )
ot_check_test ( ConstantNumericalMathHessianImplementation_std )
ot_check_test ( MethodBoundNumericalMathEvaluationImplementation_std )
ot_check_test ( NumericalMathFunction_analytical )
ot_check_test ( NumericalMathFunction_indicator )
ot_check_test ( NumericalMathFunction_dual_linear_combination )
ot_check_test ( NumericalMathFunction_linear_combination )
ot_check_test ( NumericalMathFunction_product )
ot_check_test ( NumericalMathFunction_data )
ot_check_test ( NumericalMathFunction_history )
ot_check_test ( UniVariatePolynomial_std )
ot_check_test ( Basis_std )
ot_check_test ( BasisSequence_std )
ot_check_test ( LAR_std )
ot_check_test ( DynamicalFunction_std )
ot_check_test ( SpatialFunction_std )
ot_check_test ( TemporalFunction_std )
ot_check_test ( BoxCoxEvaluationImplementation_std )
ot_check_test ( BoxCoxTransform_std )
ot_check_test ( InverseBoxCoxEvaluationImplementation_std )
ot_check_test ( InverseBoxCoxTransform_std )
ot_check_test ( TrendEvaluationImplementation_std )
ot_check_test ( TrendTransform_std )
ot_check_test ( InverseTrendEvaluationImplementation_std )
ot_check_test ( InverseTrendTransform_std )

# Optim
ot_check_test ( BoundConstrainedAlgorithmImplementationResult_std )

# Solver
ot_check_test ( Bisection_std )
ot_check_test ( Brent_std )
ot_check_test ( Secant_std )

# Stat
ot_check_test ( NumericalSample_std )
ot_check_test ( NumericalSample_split )
ot_check_test ( NumericalSample_large )
ot_check_test ( NumericalSample_computation )
ot_check_test ( HistoryStrategy_std )
ot_check_test ( CovarianceMatrixLapack_std )
ot_check_test ( CorrelationMatrix_std )
ot_check_test ( ConfidenceInterval_std )
ot_check_test ( TestResult_std )
ot_check_test ( LinearModelFactory_std )
ot_check_test ( LinearModel_std )
ot_check_test ( SensitivityAnalysis_std )
ot_check_test ( ProcessSample_std )
ot_check_test ( RandomGenerator_std )
ot_check_test ( SobolSequence_std )
ot_check_test ( FaureSequence_std )
ot_check_test ( HaltonSequence_std )
ot_check_test ( HaselgroveSequence_std )
ot_check_test ( ReverseHaltonSequence_std )
ot_check_test ( CorrelationAnalysis_std )
ot_check_test ( TimeSeries_std )
ot_check_test ( ExponentialCauchy_std )
ot_check_test ( FilteringWindows_std )
ot_check_test ( WelchFactory_std )
ot_check_test ( ExponentialModel_std )
ot_check_test ( CauchyModel_std )
ot_check_test ( SecondOrderModel_std )
ot_check_test ( UserDefinedSpectralModel_std )

# Graph
ot_check_test ( BarPlot_std )
ot_check_test ( Cloud_std )
ot_check_test ( Contour_std )
ot_check_test ( Curve_std )
ot_check_test ( Drawable_std )
ot_check_test ( Graph_mix )
ot_check_test ( Graph_export )
ot_check_test ( Pairs_std )
ot_check_test ( Pie_std )
ot_check_test ( Staircase_std )


# Algo
ot_check_test ( PenalizedLeastSquaresAlgorithm_std )
ot_check_test ( CorrectedLeaveOneOut_std )
ot_check_test ( KFold_std )
# ot_check_test ( Lasso_std )
# ot_check_test ( LassoFactory_std )
ot_check_test ( LeastSquaresMetaModelSelectionFactory_std )
ot_check_test ( KissFFT_std )

# Distribution
ot_check_test ( Arcsine_std )
ot_check_test ( ArcsineFactory_std )
ot_check_test ( Bernoulli_std )
ot_check_test ( BernoulliFactory_std )
ot_check_test ( Beta_std )
ot_check_test ( BetaFactory_std )
ot_check_test ( Binomial_std )
ot_check_test ( BinomialFactory_std )
ot_check_test ( Burr_std )
ot_check_test ( BurrFactory_std )
ot_check_test ( Chi_std )
ot_check_test ( ChiFactory_std )
ot_check_test ( ChiSquare_std )
ot_check_test ( ChiSquareFactory_std )
