=== python/src/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

add_definitions ( -DSWIG_TYPE_TABLE=openturns )

# generate SWIG runtime header
set ( SWIG_PYTHON_OPTIONS "-python" )
add_custom_command ( OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/swig_runtime.hxx
                     COMMAND ${SWIG_EXECUTABLE}
                     ARGS ${SWIG_PYTHON_OPTIONS} ${CMAKE_SWIG_FLAGS} -external-runtime ${CMAKE_CURRENT_BINARY_DIR}/swig_runtime.hxx
                     COMMENT "SWIG runtime header generation" )
add_custom_target ( generate_swig_runtime DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/swig_runtime.hxx )
include_directories ( ${CMAKE_CURRENT_BINARY_DIR} )

include_directories ( ${INTERNAL_INCLUDE_DIRS} )
include_directories ( ${CMAKE_CURRENT_SOURCE_DIR} )

set ( OPENTURNS_PYTHON_MODULES )
macro ( ot_add_python_module MODULENAME SOURCEFILE )
  set_source_files_properties ( ${SOURCEFILE} PROPERTIES CPLUSPLUS ON )
  set_source_files_properties ( ${SOURCEFILE} PROPERTIES SWIG_MODULE_NAME ${MODULENAME} )
  ot_install_swig_file ( ${SOURCEFILE} )
  if ( ${ARGC} GREATER 2 )
    set ( SWIG_MODULE_${MODULENAME}_EXTRA_DEPS ${ARGN} )
  endif ( ${ARGC} GREATER 2 )

  if ( RPY2_FOUND )
    set ( SWIG_MODULE_${MODULENAME}_EXTRA_FLAGS "-DHAVE_PYTHON_PACKAGE_RPY2=1" )
  endif ( RPY2_FOUND )

  set ( swig_other_sources )
  foreach ( it ${ARGN} )
    if ( ${it} MATCHES ".*\\.i$" )
      ot_install_swig_file ( ${it} )
    else ( ${it} MATCHES ".*\\.i$" )
      set ( swig_other_sources ${swig_other_sources} "${it}" )
    endif ( ${it} MATCHES ".*\\.i$" )
  endforeach ( it )

  # workaround for a bug in UseSWIG script not supporting multiple modules and parallel compilation
  # http://www.cmake.org/pipermail/cmake/2011-January/042345.html
  if ( CMAKE_VERSION VERSION_LESS 2.8.5 )
    set( swig_extra_generated_files )
  endif ( CMAKE_VERSION VERSION_LESS 2.8.5 )
  swig_add_module ( ${MODULENAME} python ${SOURCEFILE} ${swig_other_sources} )

  add_dependencies ( ${SWIG_MODULE_${MODULENAME}_REAL_NAME} generate_swig_runtime )
  swig_link_libraries ( ${MODULENAME} OT ${PYTHON_LIBRARIES} )
  list ( APPEND OPENTURNS_PYTHON_MODULES ${MODULENAME} )
endmacro ( ot_add_python_module )



ot_install_header_file ( PythonNumericalMathEvaluationImplementation.hxx )
ot_install_header_file ( PythonWrappingFunctions.hxx )

#set_source_files_properties ( openturns_preload.c
#                              PROPERTIES COMPILE_FLAGS "-DLIBRARY_PATH=\\\"${LIBRARY_PATH}\\\"" )
#add_library( openturns_preload MODULE openturns_preload.c )
#set_target_properties ( openturns_preload PROPERTIES PREFIX "" )
#target_link_libraries ( openturns_preload OT )
#install ( TARGETS openturns_preload
#          LIBRARY DESTINATION ${OPENTURNS_PYTHON_MODULE_PATH}/openturns
#        )

ot_add_python_module ( common common_module.i
                              OTtypes.i
                              OTexceptions.i
                              Memory.i
                              Object.i
                              PersistentObject.i
                              Study.i
                              StorageManager.i
                              XMLStorageManager.i
                              Log.i
                              MPI.i
                              TTY.i
                              Path.i
                              Catalog.i
                              ResourceMap.i
                              ComparisonOperatorImplementation.i
                              ComparisonOperator.i
                              Equal.i
                              Greater.i
                              GreaterOrEqual.i
                              Less.i
                              LessOrEqual.i
                              Cache.i
                              Threadable.i
                              PlatformInfo.i
                              BoostPointerImplementation.i
                              SharedPointer.i
                              Pointer.i
                              InterfaceObject.i
                              TypedInterfaceObject.i
                              TypedCollectionInterfaceObject.i
                              BaseCommonTemplateDefs.i
                     )
ot_add_python_module ( wrapper wrapper_module.i
                               Collection.i
			       WrapperData.i
			       WrapperFile.i
			       BaseWrapperTemplateDefs.i
                     )
ot_add_python_module ( typ typ_module.i
                           PersistentCollection.i
			   DescriptionImplementation.i
			   Description.i
			   NumericalPoint.i
			   NumericalPointWithDescription.i
			   Indices.i
			   DomainImplementation.i
			   Domain.i
			   Interval.i
			   MatrixImplementation.i
			   Matrix.i
			   SquareMatrix.i
			   SymmetricMatrix.i
			   TensorImplementation.i
			   Tensor.i
			   SymmetricTensor.i
			   BaseTypTemplateDefs.i
			   ComplexMatrixImplementation.i
			   ComplexMatrix.i
			   HermitianMatrix.i 
			   SquareComplexMatrix.i
			   TriangularComplexMatrix.i
                     )
ot_add_python_module ( statistics statistics_module.i
                                  CovarianceMatrix.i
				  CorrelationMatrix.i
				  IdentityMatrix.i
				  NumericalSample.i
				  HistoryStrategyImplementation.i
				  HistoryStrategy.i
				  Compact.i
				  Full.i
				  Last.i
				  Null.i
				  ConfidenceInterval.i
				  LinearModel.i
                                  LinearModelFactory.i
                                  TestResult.i
				  ProcessSample.i
                                  RandomGenerator.i
                                  CorrelationAnalysis.i
                                  SensitivityAnalysis.i
                                  LowDiscrepancySequenceImplementation.i
				  LowDiscrepancySequence.i
				  SobolSequence.i
				  FaureSequence.i
				  HaltonSequence.i
				  HaselgroveSequence.i
				  ReverseHaltonSequence.i
				  TimeSeries.i
				  BaseStatisticsTemplateDefs.i
				  SecondOrderModelImplementation.i 
				  SecondOrderModel.i
				  ExponentialCauchy.i
				  FilteringWindowsImplementation.i
				  FilteringWindows.i
				  Hamming.i
				  Hanning.i
				  SpectralModelImplementation.i
				  SpectralModel.i
				  CovarianceModelImplementation.i
				  CovarianceModel.i
				  StationaryCovarianceModel.i
				  SpectralModelFactoryImplementation.i
				  SpectralModelFactory.i
				  UserDefinedSpectralModel.i
				  WelchFactory.i
				  ExponentialModel.i
				  CauchyModel.i
                     )
ot_add_python_module ( graph graph_module.i
                             DrawableImplementation.i
			     Drawable.i
			     GraphImplementation.i
			     Graph.i
			     BarPlot.i
                             Cloud.i
                             Contour.i
                             Curve.i
                             Pairs.i
                             Pie.i
                             Staircase.i
                             BaseGraphTemplateDefs.i
                     )
ot_add_python_module ( func func_module.i
                            SpecFunc.i
                            NumericalMathEvaluationImplementation.i
                            NumericalMathGradientImplementation.i
			    NumericalMathHessianImplementation.i
			    NoNumericalMathEvaluationImplementation.i
			    NoNumericalMathGradientImplementation.i
			    NoNumericalMathHessianImplementation.i
			    LinearNumericalMathEvaluationImplementation.i
			    LinearNumericalMathGradientImplementation.i
			    QuadraticNumericalMathEvaluationImplementation.i
			    ConstantNumericalMathGradientImplementation.i
			    ConstantNumericalMathHessianImplementation.i
			    ComputedNumericalMathEvaluationImplementation.i
			    ComputedNumericalMathGradientImplementation.i
			    ComputedNumericalMathHessianImplementation.i
                            ComposedNumericalMathEvaluationImplementation.i
                            ComposedNumericalMathGradientImplementation.i
                            ComposedNumericalMathHessianImplementation.i
                            DualLinearCombinationEvaluationImplementation.i
                            DualLinearCombinationGradientImplementation.i
                            DualLinearCombinationHessianImplementation.i
                            LinearCombinationEvaluationImplementation.i
                            LinearCombinationGradientImplementation.i
                            LinearCombinationHessianImplementation.i
			    ProductNumericalMathEvaluationImplementation.i
			    ProductNumericalMathGradientImplementation.i
			    ProductNumericalMathHessianImplementation.i
			    NumericalMathFunctionImplementation.i
			    ComposedNumericalMathFunction.i
			    ProductNumericalMathFunction.i
			    NumericalMathFunction.i
			    DynamicalFunctionImplementation.i
			    DynamicalFunction.i
			    SpatialFunction.i
			    TemporalFunction.i
			    LinearNumericalMathFunction.i
			    UniVariatePolynomialImplementation.i
                            UniVariatePolynomial.i
			    AggregatedNumericalMathEvaluationImplementation.i
			    AnalyticalNumericalMathEvaluationImplementation.i
			    DatabaseNumericalMathEvaluationImplementation.i
                            IndicatorNumericalMathEvaluationImplementation.i
                            ProductPolynomialEvaluationImplementation.i
                            Basis.i
                            BasisSequenceImplementation.i
                            BasisSequence.i
                            BasisSequenceFactoryImplementation.i
                            BasisSequenceFactory.i
                            LAR.i
                            LARLasso.i
                            LARFSZero.i
                            BaseFuncTemplateDefs.i 
			    BoxCoxEvaluationImplementation.i
                            BoxCoxTransform.i
			    InverseBoxCoxEvaluationImplementation.i
                            PythonNumericalMathEvaluationImplementation.cxx
			    InverseBoxCoxTransform.i
			    TrendEvaluationImplementation.i
			    TrendTransform.i
			    InverseTrendEvaluationImplementation.i
			    InverseTrendTransform.i
                     )

ot_add_python_module ( diff diff_module.i
                            FiniteDifferenceStepImplementation.i
                            FiniteDifferenceStep.i
                            ConstantStep.i
                            BlendedStep.i
                            FiniteDifferenceGradient.i
                            FiniteDifferenceHessian.i
                            CenteredFiniteDifferenceGradient.i
                            CenteredFiniteDifferenceHessian.i
                            NonCenteredFiniteDifferenceGradient.i
                            BaseDiffTemplateDefs.i
                     )

ot_add_python_module ( optim optim_module.i
                             BoundConstrainedAlgorithmImplementationResult.i
			     BoundConstrainedAlgorithmImplementation.i
			     BoundConstrainedAlgorithm.i
			     NearestPointAlgorithmImplementationResult.i
