=== python/test/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

cmake_minimum_required ( VERSION 2.8 )

#include ( CTest )

set ( NEW_PATH "$ENV{PATH}:${EXAMPLE_PATH}" )

set ( PYINSTALLCHECK_ENVIRONMENT "OPENTURNS_WRAPPER_PATH=${WRAPPER_PATH}"
                                 "OPENTURNS_CONFIG_PATH=${SYSCONFIG_PATH}/openturns"
                                 "OPENTURNS_NUMERICALSAMPLE_PATH=${SAMPLE_PATH}"
                                 "PATH=${NEW_PATH}"
                                 "PYTHONPATH=${PYTHON_MODULE_PATH}"
    )

# This macro compiles on the fly and run the corresponding post-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set ( PYINSTALLCHECK_TO_BE_RUN )
macro ( ot_pyinstallcheck_test TESTNAME )
  set ( TESTNAME_TGT t_${TESTNAME} )
  set ( TESTNAME_SRC ${TESTNAME_TGT}.py )
  set ( TESTNAME_OUT ${TESTNAME_TGT}.expout )
  get_source_file_property ( OUTFILE_LOC ${TESTNAME_OUT} LOCATION )
  #add_executable ( ${TESTNAME_TGT} EXCLUDE_FROM_ALL ${TESTNAME_SRC} )
  #target_link_libraries ( ${TESTNAME_TGT} OT )
  get_source_file_property ( TESTNAME_LOC ${TESTNAME_SRC} LOCATION )

  set ( _CMD )
  set ( _PRE )
  set ( _POST )
  set ( _PARAMS )
  set ( _IGNOREOUT OFF )
  foreach ( _ARG ${ARGN} )
    string ( TOUPPER ${_ARG} ARG )
    if ( ${ARG} MATCHES PRE )
      set ( _CMD PRE )
    elseif ( ${ARG} MATCHES POST )
      set ( _CMD POST )
    elseif ( ${ARG} MATCHES PARAMS )
      set ( _CMD PARAMS )
    elseif ( ${ARG} MATCHES IGNOREOUT )
      set ( _IGNOREOUT ON )
    else ( ${ARG} MATCHES PRE )
      if ( ${_CMD} MATCHES PRE )
        set ( _PRE "${_PRE} ${_ARG} && " )
      elseif ( ${_CMD} MATCHES POST )
        set ( _POST "${_POST} && ${_ARG}" )
      elseif ( ${_CMD} MATCHES PARAMS )
        set ( _PARAMS "${_PARAMS} ${_ARG}" )
      endif  ( ${_CMD} MATCHES PRE )
      set ( _CMD )
    endif ( ${ARG} MATCHES PRE )
  endforeach ( _ARG )

  if (_IGNOREOUT)
    set ( COMMAND "( ${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} > /dev/null )" )
  else (_IGNOREOUT)
    set ( COMMAND "( ${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out ) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out" )
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    add_test ( pyinstallcheck_${TESTNAME} "sh" "-c" "${_PRE}${COMMAND}${_POST}" )
  else (_PRE OR _POST)
    add_test ( pyinstallcheck_${TESTNAME} "sh" "-c" "${COMMAND}" )
  endif (_PRE OR _POST)
  set_tests_properties ( pyinstallcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${PYINSTALLCHECK_ENVIRONMENT}" )
  list ( APPEND PYINSTALLCHECK_TO_BE_RUN ${TESTNAME_SRC} )
  install ( FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH} 
            PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
          )
endmacro ( ot_pyinstallcheck_test )


## Python post-installation tests

# Algo
ot_pyinstallcheck_test ( PenalizedLeastSquaresAlgorithm_std )
ot_pyinstallcheck_test ( KFold_std )
ot_pyinstallcheck_test ( CorrectedLeaveOneOut_std )
ot_pyinstallcheck_test ( LeastSquaresMetaModelSelectionFactory_std )
ot_pyinstallcheck_test ( KissFFT_std )

# Common
ot_pyinstallcheck_test ( ComparisonOperator_std )
ot_pyinstallcheck_test ( Path_std IGNOREOUT )
ot_pyinstallcheck_test ( ResourceMap_std IGNOREOUT )
ot_pyinstallcheck_test ( Catalog_std IGNOREOUT )

# Type
ot_pyinstallcheck_test ( Collection_std )
ot_pyinstallcheck_test ( Description_std )
ot_pyinstallcheck_test ( Indices_std )
ot_pyinstallcheck_test ( Interval_std )
ot_pyinstallcheck_test ( NumericalPoint_std )
ot_pyinstallcheck_test ( NumericalPoint_description )
ot_pyinstallcheck_test ( Matrix_std )
ot_pyinstallcheck_test ( SymmetricMatrixLapack_std )
ot_pyinstallcheck_test ( SquareMatrixLapack_std )
ot_pyinstallcheck_test ( SquareMatrix_std )
ot_pyinstallcheck_test ( SymmetricMatrix_std )
ot_pyinstallcheck_test ( Tensor_std )
ot_pyinstallcheck_test ( SymmetricTensor_std )
ot_pyinstallcheck_test ( MatrixSolveLinearSystem_std )
ot_pyinstallcheck_test ( MatrixSingularValues_std )
ot_pyinstallcheck_test ( IdentityMatrix_std )
ot_pyinstallcheck_test ( NumericalPoint_python )
ot_pyinstallcheck_test ( Domain_std )
ot_pyinstallcheck_test ( RegularGrid_std )
ot_pyinstallcheck_test ( ComplexMatrix_std )
ot_pyinstallcheck_test ( SquareComplexMatrix_std )
ot_pyinstallcheck_test ( HermitianMatrix_std )
ot_pyinstallcheck_test ( TriangularComplexMatrix_std )

# Func
ot_pyinstallcheck_test ( WrapperFile_std )
ot_pyinstallcheck_test ( NumericalMathFunction_std )
ot_pyinstallcheck_test ( NumericalMathFunction_grad )
ot_pyinstallcheck_test ( NumericalMathFunction_hess )
ot_pyinstallcheck_test ( NumericalMathFunction_sample )
ot_pyinstallcheck_test ( NumericalMathFunction_timeseries )
ot_pyinstallcheck_test ( NumericalMathFunction_composition )
ot_pyinstallcheck_test ( NumericalMathFunction_exec )
ot_pyinstallcheck_test ( NumericalMathFunction_exec_external PARAMS "system=LINUX" PRE "cp ${CMAKE_CURRENT_SOURCE_DIR}/poutre_external_infile1 ${CMAKE_CURRENT_SOURCE_DIR}/poutre_external_infile2 ${CMAKE_CURRENT_BINARY_DIR}" POST "rm -f ${CMAKE_CURRENT_BINARY_DIR}/poutre_external_infile1 ${CMAKE_CURRENT_BINARY_DIR}/poutre_external_infile2 ${CMAKE_CURRENT_BINARY_DIR}/poutre_external_outfile" )
ot_pyinstallcheck_test ( NumericalMathFunction_exec_sample )
ot_pyinstallcheck_test ( NumericalMathFunction_exec_threads )
ot_pyinstallcheck_test ( NumericalMathFunction_minimal )
ot_pyinstallcheck_test ( NumericalMathFunction_python )
ot_pyinstallcheck_test ( NumericalMathFunction_python_save IGNOREOUT )
ot_pyinstallcheck_test ( NumericalMathFunction_python_load IGNOREOUT )
ot_pyinstallcheck_test ( NumericalMathFunction_wrapper_error )
ot_pyinstallcheck_test ( NumericalMathFunction_data )
ot_pyinstallcheck_test ( NumericalMathFunction_history )
ot_pyinstallcheck_test ( LinearNumericalMathEvaluationImplementation_std )
ot_pyinstallcheck_test ( LinearNumericalMathFunction_std )
ot_pyinstallcheck_test ( LinearCombinationEvaluationImplementation_std )
ot_pyinstallcheck_test ( LinearCombinationGradientImplementation_std )
ot_pyinstallcheck_test ( LinearCombinationHessianImplementation_std )
ot_pyinstallcheck_test ( QuadraticNumericalMathEvaluationImplementation_std )
ot_pyinstallcheck_test ( LinearNumericalMathGradientImplementation_std )
ot_pyinstallcheck_test ( NumericalMathFunction_analytical )
ot_pyinstallcheck_test ( NumericalMathFunction_dual_linear_combination )
ot_pyinstallcheck_test ( NumericalMathFunction_indicator )
ot_pyinstallcheck_test ( NumericalMathFunction_linear_combination )
ot_pyinstallcheck_test ( ConstantNumericalMathGradientImplementation_std )
ot_pyinstallcheck_test ( ConstantNumericalMathHessianImplementation_std )
ot_pyinstallcheck_test ( MergeRandomAndConstantInput )
ot_pyinstallcheck_test ( Basis_std )
ot_pyinstallcheck_test ( BasisSequence_std )
ot_pyinstallcheck_test ( LAR_std )
ot_pyinstallcheck_test ( DynamicalFunction_std )
ot_pyinstallcheck_test ( SpatialFunction_std )
ot_pyinstallcheck_test ( TemporalFunction_std )
ot_pyinstallcheck_test ( BoxCoxEvaluationImplementation_std )
ot_pyinstallcheck_test ( BoxCoxTransform_std )
ot_pyinstallcheck_test ( InverseBoxCoxEvaluationImplementation_std )
ot_pyinstallcheck_test ( InverseBoxCoxTransform_std )
ot_pyinstallcheck_test ( TrendEvaluationImplementation_std )
ot_pyinstallcheck_test ( TrendTransform_std )
ot_pyinstallcheck_test ( InverseTrendEvaluationImplementation_std )
ot_pyinstallcheck_test ( InverseTrendTransform_std )

# Stat
ot_pyinstallcheck_test ( NumericalSample_std )
ot_pyinstallcheck_test ( NumericalSample_computation )
ot_pyinstallcheck_test ( NumericalSample_split )
ot_pyinstallcheck_test ( NumericalSample_large )
ot_pyinstallcheck_test ( NumericalSample_bug14 )
ot_pyinstallcheck_test ( NumericalSample_csv )
ot_pyinstallcheck_test ( HistoryStrategy_std )
ot_pyinstallcheck_test ( CovarianceMatrixLapack_std )
ot_pyinstallcheck_test ( CorrelationMatrix_std )
ot_pyinstallcheck_test ( LinearModel_std )
ot_pyinstallcheck_test ( LinearModelFactory_std )
ot_pyinstallcheck_test ( ProcessSample_std )
ot_pyinstallcheck_test ( RandomGenerator_std )
ot_pyinstallcheck_test ( SobolSequence_std )
ot_pyinstallcheck_test ( FaureSequence_std )
ot_pyinstallcheck_test ( HaltonSequence_std )
ot_pyinstallcheck_test ( HaselgroveSequence_std )
ot_pyinstallcheck_test ( ReverseHaltonSequence_std )
ot_pyinstallcheck_test ( TestResult_std )
ot_pyinstallcheck_test ( ConfidenceInterval_std )
ot_pyinstallcheck_test ( SensitivityAnalysis_std )
ot_pyinstallcheck_test ( CorrelationAnalysis_std )
ot_pyinstallcheck_test ( TimeSeries_std )
ot_pyinstallcheck_test ( ExponentialCauchy_std )
ot_pyinstallcheck_test ( FilteringWindows_std )
ot_pyinstallcheck_test ( WelchFactory_std )
ot_pyinstallcheck_test ( ExponentialModel_std )
ot_pyinstallcheck_test ( CauchyModel_std )
ot_pyinstallcheck_test ( SecondOrderModel_std )
ot_pyinstallcheck_test ( UserDefinedSpectralModel_std )

## Graph
ot_pyinstallcheck_test ( BarPlot_std )
ot_pyinstallcheck_test ( Cloud_std )
ot_pyinstallcheck_test ( Contour_std )
ot_pyinstallcheck_test ( Curve_std )
ot_pyinstallcheck_test ( Drawable_std )
ot_pyinstallcheck_test ( Graph_export )
ot_pyinstallcheck_test ( Graph_mix )
ot_pyinstallcheck_test ( Pairs_std )
ot_pyinstallcheck_test ( Pie_std )
ot_pyinstallcheck_test ( Staircase_std )

## Diff
ot_pyinstallcheck_test ( FiniteDifferenceStep_std )
ot_pyinstallcheck_test ( CenteredFiniteDifferenceGradient_std )
ot_pyinstallcheck_test ( CenteredFiniteDifferenceHessian_std )
ot_pyinstallcheck_test ( NonCenteredFiniteDifferenceGradient_std )

## Optim
ot_pyinstallcheck_test ( AbdoRackwitz_std )
ot_pyinstallcheck_test ( AbdoRackwitz_linear )
ot_pyinstallcheck_test ( AbdoRackwitz_nonlinear )
ot_pyinstallcheck_test ( NearestPointChecker_std )
ot_pyinstallcheck_test ( Cobyla_std )
ot_pyinstallcheck_test ( Cobyla_linear )
ot_pyinstallcheck_test ( Cobyla_nonlinear )
ot_pyinstallcheck_test ( SQP_std )
ot_pyinstallcheck_test ( SQP_linear )
ot_pyinstallcheck_test ( SQP_nonlinear )
ot_pyinstallcheck_test ( BoundConstrainedAlgorithmImplementationResult_std )
ot_pyinstallcheck_test ( TNC_std )
ot_pyinstallcheck_test ( TNC_linear )
ot_pyinstallcheck_test ( TNC_nonlinear )

## Solver
ot_pyinstallcheck_test ( Brent_std )
ot_pyinstallcheck_test ( Bisection_std )
ot_pyinstallcheck_test ( Secant_std )

## Model
ot_pyinstallcheck_test ( Event_std )
ot_pyinstallcheck_test ( StandardEvent_std )
ot_pyinstallcheck_test ( RandomVector_constant )
ot_pyinstallcheck_test ( RandomVector_distribution )
ot_pyinstallcheck_test ( RandomVector_function )
ot_pyinstallcheck_test ( RandomVector_conditional )

## Process
ot_pyinstallcheck_test ( WhiteNoise_std )
ot_pyinstallcheck_test ( RandomWalk_std )
ot_pyinstallcheck_test ( ARMAState_std )
ot_pyinstallcheck_test ( ARMACoefficients_std )
