=== debian/changelog ===
openturns (1.0-4) unstable; urgency=low

  [ Denis Barbier ]
  * debian/patches/test-output.patch: New patch.
    Fix test output, some compilers print 'df(x)=' twice because
    exception is thrown after text is printed to stdout.
  * debian/patches/ftbfs-clang.patch: New patch.
    Allows building with the clang compiler.
  * debian/patches/fix-bigendian.patch: New patch.
    Many checks fail on some (but not all) big endian machines,
    it seems that not all systems define __BIG_ENDIAN__.
    Add some compile-time checks to determine endianness.
  * debian/rules: Do not ignore test results for architectures
    on which tests currently pass.
  * debian/rules: Also compile algocobyla.c with -fno-cse-follow-jumps
    on kfreebsd-i386 and hurd-i386, one test hangs as on i386.
  * debian/rules: On mipsel, do not build Python libraries in
    parallel to avoid build failures due to memory problems.

 -- Denis Barbier <barbier@debian.org>  Fri, 15 Jun 2012 20:45:14 +0200

openturns (1.0-3) unstable; urgency=low

  [ Denis Barbier ]
  * debian/control: Fix dependency on r-other-rot, packages
    were not installable.
  * debian/patches/bigendian-randomgenerator.patch: New patch.
    Fix t_RandomGenerator_std unit test, it fails on PowerPC
    because of endianness.
  * debian/patches/cmake-tools.patch: New patch.
    Scripts openturns-config and openturns-module were broken.
  * Cleanup debian/patches by removing obsolete patches.  Also
    rewrite patch headers to follow DEP3.

 -- Denis Barbier <barbier@debian.org>  Sat, 19 May 2012 19:39:30 +0200

openturns (1.0-2) unstable; urgency=low

  [ Denis Barbier ]
  * debian/control: Fix dependency on tbb, it is available only on
    amd64, i386 and ia64.
  * debian/rules: Display output of failed tests to help debug failures.
  * debian/rules: Do not abort if tests fail; this was the behaviour
    when compiling with Autotools.

 -- Denis Barbier <barbier@debian.org>  Thu, 17 May 2012 17:43:20 +0200

openturns (1.0-1) experimental; urgency=low

  [ Christophe Trophime ]
  * debian/rules:
      explicit python version in override_dh_auto_configure target
  * debian/copyright:
      fix lintian warning

  [ Denis Barbier ]
  * New upstream release (Closes: #669425).
  * Build with g++ 4.6, several tests fail with g++ 4.7.
  * debian/patches/ftbfs-4.7.patch: Patch upgraded, previous
    fix had been applied upstream but there is another error.
  * debian/patches/debian-soname.patch: New patch.
    Use a Debian specific SONAME (0.1), upstream does
    not yet take care of SONAME.
    Rename libopenturns0 package into libopenturns0.1.
  * debian/patches/no-link-python.patch: New patch.
    Bugfix: "python-openturns is unusable" (Closes: #670066)
  * debian/rules: Compile algocobyla.c with -fno-cse-follow-jumps
    to work around an undefined GCC bug which makes one test
    hang on x86.  (Closes: #666782)
  * Do not build-depends on doxygen-latex, docbook-to-man.
  * Build-depends on bison, flex and bc (the latter is needed to run
    one test).
  * Move rotRpackage into a new binary package: r-other-rot, and
    let libopenturns0.1 depend on this package.  (Closes: #662800)
  * Install files into versioned directories /usr/lib/openturns-1.0
    and /etc/openturns-1.0 to avoid file conflicts during library
    transitions.
  * Add myself to Uploaders.

  [ Julien Schueller ]
  * Remove openturns-wrapper package, its files are now shipped
    by libopenturns0, libopenturns-dev and openturns-examples.
  * Moved dtd files to libopenturns0
  * Added missing generic wrapper to libopenturns0
  * Added python-openturns-dev
  * Added dependency to libtbb

 -- Denis Barbier <barbier@debian.org>  Wed, 16 May 2012 20:03:53 +0200

openturns (0.15-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "ftbfs with GCC-4.7": add patch from Denis Barbier: move declaration
    of streamObject before first usage.
    (Closes: #667315)

 -- gregor herrmann <gregoa@debian.org>  Sat, 21 Apr 2012 13:54:09 +0200

openturns (0.15-3) unstable; urgency=low

  * Team upload. (Closes: #662792).
  * Getting rid of unneeded *.la (Closes: #622492).
  * Transition to dh_python2 (Closes: #616928).
  * Use dh rules.tiny, enable parallel build.

 -- Aron Xu <aron@debian.org>  Mon, 26 Mar 2012 08:40:35 +0000

openturns (0.15-2) unstable; urgency=low

  * openturns-wrappers: install wrappers, wrapper.xml and wrapper.dtd

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 09 Sep 2011 06:34:05 +0200

openturns (0.15-1) unstable; urgency=low

  * New upstream release

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 30 Aug 2011 12:12:18 +0200

openturns (0.13.2-8) unstable; urgency=low

  * debian/control: add python-qt4 depends to python-openturns and
    openturns-examples now depends on python-openturns

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 28 Dec 2010 16:12:44 +0100

openturns (0.13.2-7) unstable; urgency=low

  [Christophe Prud'homme]
  * Bug fix: "creates a mess in sys.path by adding its own namespace",
    thanks to Bernd Zeimetz (Closes: #606870).
  * Bug fix: "Preparations for the removal of the KDE3 and Qt3 libraries",
    thanks to Eckhart Wörner (Closes: #604605).

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 28 Dec 2010 08:14:21 +0100

openturns (0.13.2-6) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/rules: reduce optimization level to O1 on armel

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 13 Aug 2010 15:44:53 +0200

openturns (0.13.2-5) unstable; urgency=low

  [Christophe Prud'homme]
  * Bug fix: "FTBFS with Python 2.6: Could not link test program to
    Python.", thanks to Jakub Wilk (Closes: #586351).

 -- Christophe Prud'homme <prudhomm@debian.org>  Sat, 19 Jun 2010 07:22:38 +0200

openturns (0.13.2-4) unstable; urgency=low

  * Bug fix: "ftbfs with gcc-4.5", thanks to Matthias Klose (Closes:
    #565081).

 -- Christophe Prud'homme <prudhomm@debian.org>  Wed, 09 Jun 2010 21:55:51 +0200


